SystemOrganization addCategory: #'Athens-Examples'!

Object subclass: #AthensSurfaceExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Examples'!

!AthensSurfaceExamples commentStamp: 'IgorStasenko 1/17/2012 16:42' prior: 0!
AthensCairoSurfaceExamples example1.
AthensCairoSurfaceExamples example2.

AthensBalloonSurfaceExamples example6.!

AthensSurfaceExamples subclass: #AthensBalloonSurfaceExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Examples'!

!AthensBalloonSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'sig 2/29/2012 21:37'!
newSurface: extent
	
	^ AthensBalloonSurface extent: extent! !

AthensSurfaceExamples subclass: #AthensCairoSurfaceExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Examples'!

!AthensCairoSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/27/2012 19:26'!
exampleInterop

"
self exampleInterop

Test the interoperability with bitblt.
A cairo image surface bits are exposed to bitblt operations via surface plugin.
"
	| surf |
	
	surf := self newSurface: 100@100.
	
	surf asForm getCanvas fillRectangle: (0@0 corner: 50@50) color: Color red.

	
	surf drawDuring: [:can |
		surf clear.
		can pathTransform loadIdentity.
		can pathTransform translateX: 30 Y: 30.
		can pathTransform rotateByDegrees: 35.
		can setPaint: (Color red).
		
		can setShape: (-20@ -20 corner: 20@ 20).
		2 timesRepeat: [ can draw. can setPaint: (Color green alpha:0.5)]
	].
	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensCairoSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/6/2012 15:29'!
newSurface: extent
	
	^ AthensCairoSurface extent: extent! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 3/13/2012 16:24'!
example1

"
self subclasses anyOne example1
"
	| surf |
	
	surf := self newSurface: 100@100.
	
	surf drawDuring: [:can |
		surf clear.
		can pathTransform loadIdentity.
		can pathTransform translateX: 30 Y: 30.
		can pathTransform rotateByDegrees: 35.
		can setPaint: (Color red).
		
		can setShape: (-20@ -20 corner: 20@ 20).
		2 timesRepeat: [ can draw. can setPaint: (Color green alpha:0.5)]
	].
	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/21/2012 18:58'!
example10 
" draw a rounded rectangle, using the arc segments

AthensCairoSurfaceExamples example10.
"

	| surf |
	
	surf := self newSurface: 440@440.
	
	surf drawDuring: [:can |
		| p |
		surf clear.
		can pathTransform
			scaleBy: 3;
			translateX: 10 Y: 10.
		p:= can createPath: [:path | |halfPi |
				halfPi := Float pi /2.
				path 
					relative;
					moveTo: 10@0;
					lineTo: 40@0;
					ccwArcTo: 10@10 angle: halfPi;
					lineTo: 0@40;
					cwArcTo: -10@10 angle: halfPi;
					lineTo: -40@0;
					cwArcTo: -10@ -10 angle: halfPi;
					lineTo: 0@ -40;
					ccwArcTo: 10@ -10 angle: halfPi].
				
		can setShape: p.
		can setPaint: Color white.
		can draw.
		can setStrokePaint: Color red.
		can draw ].
		
	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'sig 2/29/2012 22:04'!
example2
"
Draw a path on surface.

self example2.


"

	| surf |
	
	surf := self newSurface: 100@100.
	
	surf drawDuring: [:can |
		surf clear.
		
		can setPaint: Color blue.
		
		can drawShape: (
			can createPath: [:path |
				path 
					absolute;
					lineTo: 50@0;
					lineTo: 50@50;
					lineTo: 0@50
			])
	
	].

	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 14:04'!
example3
" 
Draw simple filled path, changing the transformation and colors to get some animated effects.

 self example3 
"

	| surf |
	
	surf := self newSurface: 400@400.
	
	surf drawDuring: [:can | | transform path |
	
		can setPaint: Color blue.

		can pathTransform translateX: 200 Y: 200.	
		can pathTransform scaleBy: 6.

		path := can createPath: [:pathbuilder |
			pathbuilder 
				absolute;
				moveTo: -25 @ -25;
				curveVia: 25@ -25 to: 25@25;
				curveVia: -25@25 to: -25@ -25
		].
		
		
			1 to: 1000 do: [:i |
				can setPaint: Color random.

				can pathTransform restoreAfter: [

					can pathTransform rotateByDegrees: i*5.
					can pathTransform scaleBy: (1- ( i/2000)).
					can drawShape: path.
				].
				Display getCanvas drawImage: 	surf asForm  at: 0@0. 
		]	
	].
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 14:07'!
example3stroke
" 
Draw simple stroke  path, changing the transformation and colors to get some animated effects.

 self example3stroke 
"

	| surf |
	
	surf := self newSurface: 400@400.
	
	surf drawDuring: [:can | | transform path |
	
		(can setStrokePaint: Color blue) width: 1.

		can pathTransform translateX: 200 Y: 200.	
		can pathTransform scaleBy: 1.

		path := can createPath: [:pathbuilder |
				pathbuilder 
					absolute;
					moveTo: -25 @ -25;
					curveVia: 25@ -25 to: 25@25;
					curveVia: -25@25 to: -25@ -25
			].
		
		1 to: 1000 do: [:i |
		
			(can setStrokePaint: Color random) width: 1.
			can pathTransform restoreAfter: [
				can pathTransform rotateByDegrees: i*5.
				can pathTransform scaleBy: (1- ( i/2000)).
				can drawShape: path.
			].
			Display getCanvas drawImage: 	surf asForm  at: 0@0. 
		]	
	].
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'sig 2/29/2012 22:21'!
example4
	" 
	This example demostrates that same path could be reused multiple times when drawing.
	First, we creating a path, and later we can use it in #drawShape: command.
	"

	| surf path |
	
	surf := self newSurface: 100@100.
	
	path :=  surf createRectanglePath: (0@ 0 corner: 20@ 20).
	
	surf drawDuring: [:can |
		surf clear.
		can pathTransform loadIdentity.
		can setPaint: (Color red).
		can pathTransform translateX: 5 Y: 5.
		can drawShape: path.
		can setPaint: (Color blue).
		can pathTransform translateX: 5 Y: 5.
		can drawShape: path.
	].
	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 17:28'!
example5
" draw a hollow rectangle (frame) using lineTo/moveTo commands,
 with path, consisting of two contours: outer and inner one.

Note how #moveTo: command implicitly starts new contour
when inssued in the middle of command chain.
"

	| surf |
	
	surf := self newSurface: 100@100.
	
	surf drawDuring: [:can |
		surf clear.
		
		can setPaint: Color blue.
		
		can drawShape: (
			can createPath: [:path |
				path 
					absolute;
					lineTo: 50@0;
					lineTo: 50@50;
					lineTo: 0@50;
					moveTo: 10@10;
					lineTo: 10@40;
					lineTo: 40@40;
					lineTo: 40@10
			])
	
	].

	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'sig 2/29/2012 22:21'!
example6
"Draw two rectangles, filled by linear gradient. 

Note that it should produce same rectangles with exact same fills, because gradient paint 
coordinates are affected by pathTransform matrix.


self example6
"

	| surf paint |
	
	surf := self newSurface: 100@100.
	
	paint := surf 
		createLinearGradient: { 0->Color red .  1->Color green } 
		origin: 0@0 
		corner: 50@50.
	
	surf drawDuring: [:can |
		surf clear.
		
		can setPaint: paint.

		can drawShape: (0@0 corner: 50@50).
		
		can pathTransform translateX: 50 Y: 50.
		can drawShape: (0@0 corner: 50@50).
		
	].

	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'sig 2/29/2012 22:21'!
example6stroke
"
self example6stroke


Draw two rectangles, stoked by linear gradient. 

Note that it should produce same rectangles with exact same fills, because gradient paint 
coordinates are affected by pathTransform matrix.
"

	| surf paint |
	
	surf := self newSurface: 100@100.
	
	paint := surf 
		createLinearGradient: { 0->Color red .  1->Color green } 
		origin: 0@0 
		corner: 50@50.
	
	surf drawDuring: [:can | | stroke |
		surf clear.
		
		stroke := can setStrokePaint: paint.
		stroke width: 4.
		can drawShape: (0@0 corner: 50@50).
		
		can pathTransform translateX: 50 Y: 50.
		can drawShape: (0@0 corner: 50@50).
		
	].

	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/8/2012 13:57'!
example7
"Draw two rectangles, filled by linear gradient. 
Rotate the gradient in a loop.

Note that it should produce same rectangles with exact same fills, because gradient paint 
coordinates are affected by pathTransform matrix.
"

	| surf paint |
	
	surf := self newSurface: 100@100.
	
	paint := surf 
		createLinearGradient: { 0->Color red .  1->Color green } 
		origin: 0@0 
		corner: 50@50.
	
	surf drawDuring: [:can |

		1 to: 10000 do: [:i |
			surf clear.

			can pathTransform loadIdentity.

			can paintTransform loadIdentity translateX: 15 Y: 15; rotateByDegrees: (i/10000 * 360).		
			can setPaint: paint.

			can drawShape: (0@0 corner: 50@50).
		
			can pathTransform translateX: 50 Y: 50.
			can drawShape: (0@0 corner: 50@50).

			Display getCanvas drawImage: 	surf asForm  at: 0@0
		].		
	].

! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'sig 2/29/2012 22:21'!
example8
"Draw a rectangle filled by radial gradient. 
"

	| surf paint |
	
	surf := self newSurface: 200@200.
	
	paint := surf 
		createCircularGradient: { 0->Color red . 1->Color green } 
		center: 100@100
		radius: 100.
	
	surf drawDuring: [:can |
			surf clear.

			can pathTransform loadIdentity.
			can setPaint: paint.

			can drawShape: (0@0 corner: 200@200).
		
			Display getCanvas drawImage: 	surf asForm  at: 0@0
	].

! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 14:09'!
example9
"
Fill the rectangle using image paint.
"

	| surf paint f bf |
	
	surf := self newSurface: 200@200.
	
	surf form getCanvas fillRectangle: surf form boundingBox color: Color white.
	
	f := Form extent: 10@10 depth: 32.
	f getCanvas fillRectangle: (0@0 corner: 5@5) color: (Color red alpha: 0.1).
	f getCanvas fillRectangle: (5@5 corner: 10@10) color: (Color green alpha: 0.1).

	paint := surf createImagePaint: f.
	
	surf drawDuring: [:can |

			can setPaint: paint.

			can drawShape: (0@0 corner: 100@200).
		
			Display getCanvas drawImage: 	surf asForm  at: 0@0
	].

! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 14:11'!
exampleStrokeRect
" 
Draw a frame rectangle, rotate & transform it in a loop

 self exampleStrokeRect
"

	| surf |
	
	surf := self newSurface: 400@400.
	
	surf drawDuring: [:can | | path |
	
		can pathTransform translateX: 200 Y: 200.	
		can pathTransform scaleBy: 8.
		
		1 to: 1000 do: [:i |
		
			(can setStrokePaint: Color random) width: 1.
			can pathTransform restoreAfter: [
				can pathTransform rotateByDegrees: i*5.
				can pathTransform scaleBy: (1- ( i/2000)).
				surf clear.
				can drawShape: (0@0 corner: 25@25) ].
			Display getCanvas drawImage: 	surf asForm  at: 0@0. 
		]	
	].
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:35'!
newSurface:  extent
	self subclassResponsibility! !
